remove duplicate section to find bridge name
[openwrt/svn-archive/archive.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5 local device="$1"
6 local wds
7 local adhoc sta ap
8
9 config_get vifs "$device" vifs
10 for vif in $vifs; do
11
12 config_get ifname "$vif" ifname
13 config_set "$vif" ifname "${ifname:-ath}"
14
15 config_get mode "$vif" mode
16 case "$mode" in
17 adhoc|sta|ap)
18 append $mode "$vif"
19 ;;
20 wds)
21 config_get addr "$vif" bssid
22 config_get ssid "$vif" ssid
23 [ -z "$addr" -a -n "$ssid" ] && {
24 config_set "$vif" wds 1
25 config_set "$vif" mode sta
26 mode="sta"
27 addr="$ssid"
28 }
29 ${addr:+append $mode "$vif"}
30 ;;
31 *) echo "$device($vif): Invalid mode, ignored."; continue;;
32 esac
33 done
34
35 case "${adhoc:+1}:${sta:+1}:${ap+1}" in
36 # valid mode combinations
37 1::) wds="";;
38 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
39 :1:);;
40 ::1);;
41 ::);;
42 *) echo "$device: Invalid mode combination in config"; return 1;;
43 esac
44
45 config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${sta:+$sta }${wds:+$wds }"
46 }
47
48
49 disable_atheros() (
50 local device="$1"
51
52 # kill all running hostapd and wpa_supplicant processes that
53 # are running on atheros vifs
54 for pid in `pidof hostapd wpa_supplicant`; do
55 grep ath /proc/$pid/cmdline >/dev/null && \
56 kill $pid
57 done
58
59 include /lib/network
60 cd /proc/sys/net
61 for dev in *; do
62 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
63 ifconfig "$dev" down
64 unbridge "$dev"
65 wlanconfig "$dev" destroy
66 }
67 done
68 return 0
69 )
70
71 enable_atheros() {
72 config_get channel "$device" channel
73 config_get vifs "$device" vifs
74
75 disable_atheros "$device"
76 local first=1
77 for vif in $vifs; do
78 nosbeacon=
79 config_get ifname "$vif" ifname
80 config_get enc "$vif" encryption
81 config_get mode "$vif" mode
82
83 [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
84
85 config_get ifname "$vif" ifname
86 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
87 [ $? -ne 0 ] && {
88 echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
89 continue
90 }
91 config_set "$vif" ifname "$ifname"
92
93 [ "$first" = 1 ] && {
94 # only need to change freq band and channel on the first vif
95 config_get agmode "$device" mode
96 pureg=0
97 case "$agmode" in
98 *b) agmode=11b;;
99 *bg) agmode=11g;;
100 *g) agmode=11g; pureg=1;;
101 *a) agmode=11a;;
102 *) agmode=11g;;
103 esac
104 iwconfig "$ifname" channel 0
105 iwpriv "$ifname" mode "$agmode"
106 iwpriv "$ifname" pureg "$pureg"
107 iwconfig "$ifname" channel "$channel"
108 }
109
110 config_get_bool hidden "$vif" hidden
111 iwpriv "$ifname" hide_ssid "$hidden"
112
113 config_get wds "$vif" wds
114 case "$wds" in
115 1|on|enabled) wds=1;;
116 *) wds=0;;
117 esac
118 iwpriv "$ifname" wds "$wds"
119
120 wpa=
121 case "$enc" in
122 WEP|wep)
123 for idx in 1 2 3 4; do
124 config_get key "$vif" "key${idx}"
125 iwconfig "$ifname" enc "[$idx]" "${key:-off}"
126 done
127 config_get key "$vif" key
128 iwconfig "$ifname" enc "${key:-1}"
129 ;;
130 PSK|psk|PSK2|psk2)
131 config_get key "$vif" key
132 ;;
133 esac
134
135 case "$mode" in
136 wds)
137 config_get addr "$vif" bssid
138 iwpriv "$ifname" wds_add "$addr"
139 ;;
140 *)
141 config_get ssid "$vif" ssid
142 ;;
143 esac
144
145 [ "$mode" = "sta" ] && {
146 config_get_bool bgscan "$vif" bgscan 1
147 iwpriv "$ifname" bgscan "$bgscan"
148 }
149
150 config_get_bool antdiv "$device" diversity 1
151 sysctl -w dev."$device".diversity="$antdiv" >&-
152
153 config_get antrx "$device" rxantenna
154 if [ -n "$antrx" ]; then
155 sysctl -w dev."$device".rxantenna="$antrx" >&-
156 fi
157
158 config_get anttx "$device" txantenna
159 if [ -n "$anttx" ]; then
160 sysctl -w dev."$device".txantenna="$anttx" >&-
161 fi
162
163 config_get distance "$device" distance
164 if [ -n "$distance" ]; then
165 athctrl -i "$device" -d "$distance" >&-
166 fi
167
168 config_get txpwr "$vif" txpower
169 if [ -n "$txpwr" ]; then
170 iwconfig "$ifname" txpower "${txpwr%%.*}"
171 fi
172
173 ifconfig "$ifname" up
174
175 local net_cfg bridge
176 net_cfg="$(find_net_config "$vif")"
177 [ -z "$net_cfg" ] || {
178 bridge="$(bridge_interface "$net_cfg")"
179 config_set "$vif" bridge "$bridge"
180 start_net "$ifname" "$net_cfg"
181 }
182 iwconfig "$ifname" essid "$ssid"
183 case "$mode" in
184 ap)
185 hostapd_setup_vif "$vif" madwifi || {
186 echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
187 # make sure this wifi interface won't accidentally stay open without encryption
188 ifconfig "$ifname" down
189 wlanconfig "$ifname" destroy
190 continue
191 }
192 ;;
193 wds|sta)
194 case "$enc" in
195 PSK|psk|PSK2|psk2)
196 case "$enc" in
197 PSK|psk)
198 proto='proto=WPA';;
199 PSK2|psk2)
200 proto='proto=RSN';;
201 esac
202 cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
203 ctrl_interface=/var/run/wpa_supplicant
204 network={
205 scan_ssid=1
206 ssid="$ssid"
207 key_mgmt=WPA-PSK
208 $proto
209 psk="$key"
210 }
211 EOF
212 ;;
213 WPA|wpa|WPA2|wpa2)
214 #add wpa_supplicant calls here
215 ;;
216 esac
217 wpa_supplicant ${bridge:+ -b $bridge} -Bw -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
218 ;;
219 esac
220 first=0
221 done
222 }
223
224
225 detect_atheros() {
226 cd /proc/sys/dev
227 [ -d ath ] || return
228 for dev in wifi*; do
229 config_get type "$dev" type
230 [ "$type" = atheros ] && return
231 cat <<EOF
232 config wifi-device $dev
233 option type atheros
234 option channel 5
235 # option diversity 1
236 # option txantenna 0
237 # option rxantenna 0
238 # option distance 2000
239 # disable radio to prevent an open ap after reflashing:
240 option disabled 1
241
242
243 config wifi-iface
244 option device $dev
245 option network lan
246 option mode ap
247 option ssid OpenWrt
248 option hidden 0
249 # option txpower 15
250 # option bgscan enable
251 option encryption none
252
253 EOF
254 done
255 }